## gsmartcontrol 1.1.4+git20240531.25f1c62

=== CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2021 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################


# Generate files
configure_file("gsmartcontrol.appdata.in.xml" "gsmartcontrol.appdata.xml" ESCAPE_QUOTES @ONLY)
configure_file("gsmartcontrol.in.desktop" "gsmartcontrol.desktop" ESCAPE_QUOTES @ONLY)
configure_file("gsmartcontrol-root.in.sh" "gsmartcontrol-root.sh" ESCAPE_QUOTES @ONLY)
configure_file("org.gsmartcontrol.in.policy" "org.gsmartcontrol.policy" ESCAPE_QUOTES @ONLY)

# Install app icons
if (NOT WIN32)
	foreach(dir 16 22 24 32 48 64 128 256)
		install(FILES "${dir}/gsmartcontrol.png"
			DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/${dir}x${dir}/apps/")
	endforeach()
	# Don't run update-icon-cache, cpack is mostly for packaging.
#	install(CODE "execute_process (COMMAND gtk-update-icon-cache-3.0 -t -f \"@CMAKE_INSTALL_DATADIR@/icons/hicolor\")")
endif()

if (WIN32)
	# .ico file
	install(FILES gsmartcontrol.ico DESTINATION .)
endif()

# Install internal icons
if (WIN32)
	install(FILES icon_cddvd.png icon_hdd.png
		DESTINATION .)
else()
	install(FILES icon_cddvd.png icon_hdd.png
		DESTINATION "${CMAKE_INSTALL_DATADIR}/gsmartcontrol/icons")
endif()

# Desktop file
if (NOT WIN32)
	install(FILES "${CMAKE_CURRENT_BINARY_DIR}/gsmartcontrol.desktop"
		DESTINATION "${CMAKE_INSTALL_DATADIR}/applications/")

	# Appdata file
	install(FILES "${CMAKE_CURRENT_BINARY_DIR}/gsmartcontrol.appdata.xml"
		DESTINATION "${CMAKE_INSTALL_DATADIR}/metainfo/")

	# PolKit file
	install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.gsmartcontrol.policy"
		DESTINATION "${CMAKE_INSTALL_DATADIR}/polkit-1/actions/")

	# Man pages
	install(FILES "man1/gsmartcontrol.1" DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")
	install(FILES "man1/gsmartcontrol.1" DESTINATION "${CMAKE_INSTALL_MANDIR}/man1" RENAME "gsmartcontrol-root.1")

	# Scripts (this goes to bin, not sbin, as it doesn't require root privileges before running)
	install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/gsmartcontrol-root.sh" TYPE BIN RENAME "gsmartcontrol-root")
endif()

=== applib/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2021 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################

add_library(applib STATIC)

target_sources(applib PRIVATE
	async_command_executor.cpp
	async_command_executor.h
	app_builder_widget.h
	app_gtkmm_tools.cpp
	app_gtkmm_tools.h
	app_regex.h
	command_executor.h
	command_executor.cpp
	command_executor_3ware.h
	command_executor_areca.h
	command_executor_gui.cpp
	command_executor_gui.h
	command_executor_factory.cpp
	command_executor_factory.h
	gsc_settings.h
	gui_utils.cpp
	gui_utils.h
	selftest.cpp
	selftest.h
	smartctl_parser.cpp
	smartctl_parser.h
	smartctl_json_ata_parser.cpp
	smartctl_json_ata_parser.h
	smartctl_json_basic_parser.cpp
	smartctl_json_basic_parser.h
	smartctl_json_nvme_parser.cpp
	smartctl_json_nvme_parser.h
	smartctl_json_parser_helpers.h
	smartctl_executor.cpp
	smartctl_executor_gui.h
	smartctl_executor.h
	smartctl_parser_types.h
	smartctl_text_ata_parser.cpp
	smartctl_text_ata_parser.h
	smartctl_text_basic_parser.cpp
	smartctl_text_basic_parser.h
	smartctl_text_parser_helper.cpp
	smartctl_text_parser_helper.h
	smartctl_version_parser.cpp
	smartctl_version_parser.h
	storage_detector.cpp
	storage_detector.h
	storage_detector_helpers.h
	storage_detector_linux.cpp
	storage_detector_linux.h
	storage_detector_other.cpp
	storage_detector_other.h
	storage_detector_win32.cpp
	storage_detector_win32.h
	storage_device.cpp
	storage_device.h
	storage_property.cpp
	storage_property.h
	storage_property_descr.cpp
	storage_property_descr.h
	storage_property_repository.cpp
	storage_property_repository.h
	storage_settings.h
	warning_colors.h
	warning_level.h
	window_instance_manager.h
)

target_link_libraries(applib
	PUBLIC
		libdebug
		hz
		rconfig
		app_gtkmm_interface
		app_gettext_interface
		build_config
)

target_include_directories(applib
	PUBLIC
		"${CMAKE_SOURCE_DIR}/src"
)


add_subdirectory(examples)
add_subdirectory(tests)

=== gui/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2021 - 2024 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################

# gsmartcontrol binary
add_executable(gsmartcontrol WIN32)

target_sources(gsmartcontrol PRIVATE
	gsc_about_dialog.cpp
	gsc_about_dialog.h
	gsc_add_device_window.cpp
	gsc_add_device_window.h
	gsc_executor_error_dialog.cpp
	gsc_executor_error_dialog.h
	gsc_executor_log_window.cpp
	gsc_executor_log_window.h
	gsc_info_window.cpp
	gsc_info_window.h
	gsc_init.cpp
	gsc_init.h
	gsc_main.cpp
	gsc_main_window.cpp
	gsc_main_window.h
	gsc_main_window_iconview.h
	gsc_preferences_window.cpp
	gsc_preferences_window.h
	gsc_startup_settings.h
	gsc_text_window.h
)

# Win32 resource file
if (WIN32)
	configure_file("gsc_winres.in.rc" "${CMAKE_CURRENT_BINARY_DIR}/gsc_winres.rc" ESCAPE_QUOTES @ONLY NEWLINE_STYLE DOS)
	file(COPY "${CMAKE_SOURCE_DIR}/data/gsmartcontrol.ico" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")  # required by winres
	target_sources(gsmartcontrol PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/gsc_winres.rc")
endif()

# Win32 manifest
if (WIN32)
	set(WINDOWS_ARCH "x86")  # Needed for manifest .in file
	if (CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(WINDOWS_ARCH "amd64")
	endif()
	configure_file("gsmartcontrol.exe.in.manifest" "${CMAKE_CURRENT_BINARY_DIR}/gsmartcontrol.exe.manifest"
		ESCAPE_QUOTES @ONLY NEWLINE_STYLE DOS)

	# We link the manifest into the binary instead of installing it.
	# install(FILES "${CMAKE_CURRENT_BINARY_DIR}/gsmartcontrol.exe.manifest" DESTINATION "${CMAKE_INSTALL_SBINDIR}/")
	target_sources(gsmartcontrol PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/gsmartcontrol.exe.manifest")
endif()


target_link_libraries(gsmartcontrol
	PRIVATE
		applib
		app_gtkmm_interface
		build_config
)

if (WIN32)
	install(TARGETS gsmartcontrol DESTINATION .)
else()
	install(TARGETS gsmartcontrol DESTINATION "${CMAKE_INSTALL_SBINDIR}/")
endif()


add_subdirectory(ui)

## gsmartcontrol 0.8.6

=== debian/changelog ===
gsmartcontrol (0.8.6-1ubuntu1) precise; urgency=low

  * d/patches/glib.2.31.patch: Fixed compilation under Glib 2.31.x.
    Patch from Upstream, Alexander Shaduri (LP: #935155)

 -- Andreas Moog <amoog@ubuntu.com>  Sun, 19 Feb 2012 20:42:50 +0100

gsmartcontrol (0.8.6-1) unstable; urgency=low

  * [dbb993d] Updated my email address and removed DM-Upload-Allowed
    control field
  * [b681b5b] Imported Upstream version 0.8.6
  * [ab9bb7a] Refreshed patches
  * [a909506] Bump to Standards-Version 3.9.2, no changes needed
  * [48dd13d] Switch to dpkg-source 3.0 (quilt) format

 -- Giuseppe Iuculano <iuculano@debian.org>  Fri, 15 Jul 2011 14:59:29 +0200

gsmartcontrol (0.8.5-2) unstable; urgency=low

  * [8240961] Add menu in Depends (Closes: #548232) (LP: #438394)

 -- Giuseppe Iuculano <giuseppe@iuculano.it>  Tue, 29 Sep 2009 23:04:43 +0200

gsmartcontrol (0.8.5-1) unstable; urgency=low

  * [7f4b7f6] Imported Upstream version 0.8.5
  * [51d2a10] Refreshed patches
  * [8c6daef] Updated to Standards-Version 3.8.3 (no changes needed)
  * [30bc489] Added a README.source

 -- Giuseppe Iuculano <giuseppe@iuculano.it>  Tue, 15 Sep 2009 09:52:00 +0200

gsmartcontrol (0.8.4-2) unstable; urgency=low

  * [d6e1ccc] debian/patches/03_gcc4.4.patch: Added a missing include
    and fix FTBFS with GCC 4.4 (Closes: #525734)

 -- Giuseppe Iuculano <giuseppe@iuculano.it>  Mon, 11 May 2009 12:43:43 +0200

gsmartcontrol (0.8.4-1) unstable; urgency=low

  * [56eb25b] Fix a typo in the previous changeleg entry
  * [74046f6] New Upstream Version 0.8.4
  * [8fdb261] debian/patches/03_blacklist_md_devices.patch: Removed
  * [bdbe2af] debian/rules: Do not install debian/gsmartcontrol.1, now
    it is in upstream
  * [62c0daa] Updated watch file
  * [bc779d0] debian/rules: use dh_auto_configure
  * [07120d7] Updated to standards version 3.8.1 (No changes needed)

 -- Giuseppe Iuculano <giuseppe@iuculano.it>  Thu, 26 Mar 2009 23:18:40 +0100

gsmartcontrol (0.8.3-3) unstable; urgency=low

  * [7468f7c] debian/control: Fix Vcs-Browser field
  * [5c94558] debian/gsmartcontrol.1: gsmartcontrol supports quite a
    number of options, added to manpage. Thanks Alexander Shaduri
  * [f8e620b] debian/gsmartcontrol-root: The gsmartcontrol-root script
    was incompatible with the original one, which uses the first
    argument for desktop selection. Fixed, thanks Alexander Shaduri
  * [10861d9] debian/copyright: gsmartcontrol is released under either
    GPL 2 or GPL 3 but not any other version, so point to both of the
    specific versions of the GPL that the package license references and
    fix copyright-refers-to-versionless-license-file lintian warning.

 -- Giuseppe Iuculano <giuseppe@iuculano.it>  Wed, 04 Feb 2009 12:18:06 +0100

gsmartcontrol (0.8.3-2) unstable; urgency=low

  * [2cc4a61] debian/rules: Do not use --enable-optimize-options in
    configure, and fix FTBFS

 -- Giuseppe Iuculano <giuseppe@iuculano.it>  Sun, 01 Feb 2009 12:13:20 +0100

gsmartcontrol (0.8.3-1) unstable; urgency=low

  * Initial release (Closes: #508512)
  * debian/patches/01_use_su-to-root.patch: use su-to-root instead of upstream
    gsmartcontrol-root script
  * debian/patches/02_fix_doc_install.patch: Do not install doc and license
    files
  * debian/patches/03_blacklist_md_devices.patch: do not scan /dev/md[0-9]
    devices

 -- Giuseppe Iuculano <giuseppe@iuculano.it>  Mon, 29 Dec 2008 09:57:37 +0100

=== debian/control ===
Source: gsmartcontrol
Section: utils
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Giuseppe Iuculano <iuculano@debian.org>
Build-Depends: quilt, debhelper (>= 7), autotools-dev, libpcre3-dev, libgtkmm-2.4-dev (>= 2.6.0), libglademm-2.4-dev
Standards-Version: 3.9.2
Homepage: http://gsmartcontrol.berlios.de
Vcs-Git: git://git.debian.org/git/users/derevko-guest/gsmartcontrol.git
Vcs-Browser: http://git.debian.org/?p=users/derevko-guest/gsmartcontrol.git

Package: gsmartcontrol
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, smartmontools, menu
Description: graphical user interface for smartctl
 GSmartControl is a graphical user interface for smartctl, which is a tool for
 querying and controlling SMART (Self-Monitoring, Analysis, and Reporting
 Technology) data on modern hard disk drives. It allows you to inspect the
 drive's SMART data to determine its health, as well as run various tests on it.
 .
 Features:
 .
  * automatically reports and highlights any anomalies;
  * allows enabling/disabling Automatic Offline Data Collection;
  * allows enabling/disabling SMART itself;
  * supports configuration of global and per-drive options for smartctl;
  * performs SMART self-tests;
  * displays drive IDs, capabilities, attributes, and self-test/error logs;
  * can read in smartctl data from a saved file, interpreting it as a read-only
    virtual device.

=== debian/watch ===
version=3
http://download.berlios.de/gsmartcontrol/gsmartcontrol-(.*)\.tar\.bz2

## gsmartcontrol 0.8.7

=== debian/changelog ===
gsmartcontrol (0.8.7-1.1ubuntu2) wily; urgency=medium

  * No-change rebuild against libatkmm-1.6-1v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 07 Aug 2015 18:19:12 +0000

gsmartcontrol (0.8.7-1.1ubuntu1) vivid; urgency=medium

  * Merge from debian. Remaining changes:
    - Add 05_fix_ATA_version.patch. Correctly report the ATA/SATA version

 -- Jackson Doak <noskcaj@ubuntu.com>  Sun, 26 Oct 2014 15:41:58 +1100

gsmartcontrol (0.8.7-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Handle empty sections in recent versions of smartmontools; thanks to
    Francesco Presel for the patch. Closes: #722989.

 -- Stephen Kitt <skitt@debian.org>  Fri, 12 Sep 2014 08:40:12 +0200

gsmartcontrol (0.8.7-1ubuntu1) utopic; urgency=medium

  * Add 04_compat_with_smartmontools_6.patch. Fixes a crash at
    startup. LP: #1231229
  * Add 05_fix_ATA_version.patch. Correctly report the ATA/SATA version
    LP: #1310282

 -- Jackson Doak <noskcaj@ubuntu.com>  Mon, 09 Jun 2014 19:37:24 +1000

gsmartcontrol (0.8.7-1) unstable; urgency=low

  * [314881d] Updated debian/watch
  * [18ebada] Imported Upstream version 0.8.7
  * [c2a1f1b] debian/rules: Provide build-arch and build-indep
  * [d3036a4] Enabled Hardening Options
  * [2edfb87] Refreshed patches and removed patches apllied upstream
  * [ac3b953] Bump to standard versions 3.9.4
  * [292c276] Remove quilt from depends

 -- Giuseppe Iuculano <iuculano@debian.org>  Fri, 31 May 2013 11:41:52 +0200

gsmartcontrol (0.8.6-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "ftbfs with GCC-4.7": add patch 05_gcc-4.7.patch from Paul Tagliamonte
    (adds this-> qualifier).
    Closes: #667194

 -- gregor herrmann <gregoa@debian.org>  Sun, 22 Apr 2012 14:32:59 +0200

gsmartcontrol (0.8.6-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "FTBFS with glib 2.32": add patch 04_glib2.31.patch from Alexander
    Shaduri. (Closes: #665677, LP: #935155

 -- gregor herrmann <gregoa@debian.org>  Sun, 08 Apr 2012 14:19:47 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: extra
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Giuseppe Iuculano <iuculano@debian.org>
-Build-Depends: quilt, debhelper (>= 7), autotools-dev, libpcre3-dev, libgtkmm-2.4-dev (>= 2.6.0), libglademm-2.4-dev
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 7), autotools-dev, libpcre3-dev, libgtkmm-2.4-dev (>= 2.6.0), libglademm-2.4-dev, hardening-wrapper
+Standards-Version: 3.9.4
 Homepage: http://gsmartcontrol.berlios.de
 Vcs-Git: git://git.debian.org/git/users/derevko-guest/gsmartcontrol.git
 Vcs-Browser: http://git.debian.org/?p=users/derevko-guest/gsmartcontrol.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

export DEB_BUILD_HARDENING=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif


config.status: configure
	dh_testdir
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif
	dh_auto_configure

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp:  config.status $(QUILT_STAMPFN)
	dh_testdir
	$(MAKE)
	touch $@

clean: 
	dh_testdir
	dh_testroot
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f config.sub config.guess
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep  
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/gsmartcontrol install


binary-indep: install

binary-arch: install
	dh_testdir
	dh_testroot
	dh_installchangelogs NEWS
	dh_installdocs
	dh_installmenu
	dh_installman
	dh_link
	dh_install
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
http://sf.net/gsmartcontrol.berlios/gsmartcontrol-(.+)\.(?:tar\.gz|tar\.bz2)

## gsmartcontrol 1.0.1

=== debian/changelog ===
gsmartcontrol (1.0.1-1) unstable; urgency=medium

  * New upstream release. Closes: #864538. Obsoletes
    compat_with_smartmontools_6.patch and 05_fix_ATA_version.patch.
  * Use dh-autoreconf and stop patching Makefile.in.
  * Adopt the package; thanks to Giuseppe for maintaining it previously!
    Closes: #866834.
  * Update watch file.
  * Clean up debian/control with cme.
  * Drop the old menu support.
  * Drop obsolete README.source.
  * Clean up SUBDIRS declarations to allow building twice in a row.
  * Rewrite debian/copyright.
  * Standards-Version 4.0.0, no further change required.
  * Move the repository to collab-maint.

 -- Stephen Kitt <skitt@debian.org>  Mon, 10 Jul 2017 21:22:30 +0200

gsmartcontrol (0.8.7-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Use DEB_BUILD_MAINT_OPTIONS with short-form dh instead of
    hardening-wrapper. Closes: #836628.
  * Update the homepage. Closes: #769580.
  * Pull in 05_fix_ATA_version.patch from Ubuntu (thanks to Bart P.). LP:
    #1310282.

 -- Stephen Kitt <skitt@debian.org>  Mon, 12 Sep 2016 13:42:12 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,21 @@
 Source: gsmartcontrol
+Maintainer: Stephen Kitt <skitt@debian.org>
 Section: utils
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Giuseppe Iuculano <iuculano@debian.org>
-Build-Depends: debhelper (>= 7), autotools-dev, libpcre3-dev, libgtkmm-2.4-dev (>= 2.6.0), libglademm-2.4-dev, hardening-wrapper
-Standards-Version: 3.9.4
-Homepage: http://gsmartcontrol.berlios.de
-Vcs-Git: git://git.debian.org/git/users/derevko-guest/gsmartcontrol.git
-Vcs-Browser: http://git.debian.org/?p=users/derevko-guest/gsmartcontrol.git
+Build-Depends: debhelper (>= 9),
+               dh-autoreconf,
+               libpcre3-dev,
+               libgtkmm-3.0-dev
+Standards-Version: 4.0.0
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/gsmartcontrol.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/gsmartcontrol.git
+Homepage: http://gsmartcontrol.sourceforge.net/home/
 
 Package: gsmartcontrol
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, smartmontools, menu
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         smartmontools
 Description: graphical user interface for smartctl
  GSmartControl is a graphical user interface for smartctl, which is a tool for
  querying and controlling SMART (Self-Monitoring, Analysis, and Reporting

## gsmartcontrol 1.0.2

=== debian/changelog ===
gsmartcontrol (1.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Handle Finnish separators; thanks to Aapo Rantalainen for the patch!
    LP: #1463108.
  * Fix a spelling mistake and override a Lintian spelling false-
    positive.

 -- Stephen Kitt <skitt@debian.org>  Mon, 21 Aug 2017 09:42:52 +0200

gsmartcontrol (1.0.1-2) unstable; urgency=medium

  * The dependency on menu is needed for su-to-root, restore it.
  * Acknowledge the 0.8.7-1.2 NMU. Closes: #837546.
  * Fix quoting in gsmartcontrol-root. Closes: #723973.

 -- Stephen Kitt <skitt@debian.org>  Mon, 10 Jul 2017 21:47:49 +0200

=== debian/control ===
--- 
+++ 
@@ -15,6 +15,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
+         menu,
          smartmontools
 Description: graphical user interface for smartctl
  GSmartControl is a graphical user interface for smartctl, which is a tool for

## gsmartcontrol 1.1.1

=== debian/changelog ===
gsmartcontrol (1.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sun, 01 Oct 2017 20:32:15 +0200

gsmartcontrol (1.1.0-1) unstable; urgency=medium

  * New upstream release.
  * The “Perform Tests” tab has been merged with the “Self-Tests” tab, and
    vertical space is used appropriately (at least, if there are test
    results). Closes: #641564.
  * Upstream gsmartcontrol-root now supports pkexec, use that instead of
    our su-to-root-based script. LP: #1713311.
  * Stop shipping TODO, it’s not much use for end-users.
  * Switch to debhelper compatibility level 10.
  * Standards-Version 4.1.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 11 Sep 2017 09:22:25 +0200

=== debian/control ===
--- 
+++ 
@@ -2,21 +2,19 @@
 Maintainer: Stephen Kitt <skitt@debian.org>
 Section: utils
 Priority: extra
-Build-Depends: debhelper (>= 9),
-               dh-autoreconf,
+Build-Depends: debhelper (>= 10),
                libpcre3-dev,
                libgtkmm-3.0-dev
-Standards-Version: 4.0.0
+Standards-Version: 4.1.0
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/gsmartcontrol.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/gsmartcontrol.git
-Homepage: http://gsmartcontrol.sourceforge.net/home/
+Homepage: https://gsmartcontrol.sourceforge.io/
 
 Package: gsmartcontrol
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         menu,
-         smartmontools
+         smartmontools (>= 5.43)
 Description: graphical user interface for smartctl
  GSmartControl is a graphical user interface for smartctl, which is a tool for
  querying and controlling SMART (Self-Monitoring, Analysis, and Reporting

## gsmartcontrol 1.1.3

=== debian/changelog ===
gsmartcontrol (1.1.3-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:43:08 +0100

gsmartcontrol (1.1.3-2) unstable; urgency=medium

  * Migrate to Salsa.
  * Update spelling fixes.
  * Switch to debhelper compatibility level 11.
  * Standards-Version 4.1.4, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 07 May 2018 09:23:22 +0200

gsmartcontrol (1.1.3-1) unstable; urgency=medium

  * New upstream release.
  * Move to Priority “optional”.
  * Standards-Version 4.1.1, no further change required.
  * Enable building without fakeroot.

 -- Stephen Kitt <skitt@debian.org>  Thu, 16 Nov 2017 09:10:59 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: gsmartcontrol
 Maintainer: Stephen Kitt <skitt@debian.org>
 Section: utils
-Priority: extra
-Build-Depends: debhelper (>= 10),
+Priority: optional
+Build-Depends: debhelper (>= 11~),
                libpcre3-dev,
                libgtkmm-3.0-dev
-Standards-Version: 4.1.0
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/gsmartcontrol.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/gsmartcontrol.git
+Standards-Version: 4.1.4
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/debian/gsmartcontrol
+Vcs-Git: https://salsa.debian.org/debian/gsmartcontrol.git
 Homepage: https://gsmartcontrol.sourceforge.io/
 
 Package: gsmartcontrol

=== debian/watch ===
version=4
http://sf.net/gsmartcontrol/ gsmartcontrol-(.+)\.(?:tar\.gz|tar\.bz2) debian uupdate

## gsmartcontrol 1.1.4

=== debian/changelog ===
gsmartcontrol (1.1.4-1) unstable; urgency=medium

  * New upstream release, merging c2-separator.patch, spelling-
    fixes.patch, and fix-segfault-on-start.patch.

 -- Stephen Kitt <skitt@debian.org>  Sun, 13 Feb 2022 16:23:15 +0100

gsmartcontrol (1.1.3-3) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/watch: Use https protocol

  [ Debian Janitor ]
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Archive, Repository.
  * Update standards version to 4.1.5, no changes needed.
  * Remove constraints unnecessary since buster:
    + gsmartcontrol: Drop versioned constraint on smartmontools in Depends.

  [ Stephen Kitt ]
  * Apply upstream fix to avoid segfaulting during device scans.
    Closes: #942427.
  * Update the homepage and watch URIs.
  * Switch to debhelper compatibility level 13.
  * Drop obsolete Lintian override.
  * Standards-Version 4.6.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Fri, 28 Jan 2022 14:05:07 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Maintainer: Stephen Kitt <skitt@debian.org>
 Section: utils
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 13),
                libpcre3-dev,
                libgtkmm-3.0-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/gsmartcontrol
 Vcs-Git: https://salsa.debian.org/debian/gsmartcontrol.git
@@ -15,7 +15,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         smartmontools (>= 5.43)
+         smartmontools
 Description: graphical user interface for smartctl
  GSmartControl is a graphical user interface for smartctl, which is a tool for
  querying and controlling SMART (Self-Monitoring, Analysis, and Reporting

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
    https://github.com/ashaduri/gsmartcontrol/releases \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## gsmartcontrol 1.1.4+git20240531.25f1c62

=== debian/changelog ===
gsmartcontrol (1.1.4+git20240531.25f1c62-2) unstable; urgency=medium

  * Add the package name to file paths, so gsmartcontrol can start on
    more systems than mine! Closes: #1072624.

 -- Stephen Kitt <skitt@debian.org>  Wed, 05 Jun 2024 19:52:18 +0200

gsmartcontrol (1.1.4+git20240531.25f1c62-1) unstable; urgency=medium

  * New upstream snapshot, no longer dependent on pcre3. Closes:
    #1000074.
  * Standards-Version 4.7.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Wed, 05 Jun 2024 08:07:40 +0200

## gsmartcontrol 2.0.0

=== CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2021 - 2024 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################

# 3.14 for proper object library support (wrt linking)
cmake_minimum_required(VERSION 3.14)
# Use new policy for option() to supress warnings.
set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)


include(${CMAKE_SOURCE_DIR}/version.txt)

project(gsmartcontrol
	VERSION ${CMAKE_PROJECT_VERSION}
	DESCRIPTION "Hard Disk Drive and SSD Health Inspection Tool"
	HOMEPAGE_URL "https://gsmartcontrol.shaduri.dev"
	LANGUAGES CXX
)


# Provide DATADIR, etc.
include(GNUInstallDirs)

message(STATUS "Using toolchain file: ${CMAKE_TOOLCHAIN_FILE}")

include(src/build_config/compiler_options.cmake)


# Disable RPATH manipulation, we don't have shared libraries
set(CMAKE_SKIP_BUILD_RPATH TRUE)
set(CMAKE_SKIP_INSTALL_RPATH TRUE)

# Write the binaries to project root (avoids conflicts with manifests, also it's more convenient this way)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}")


# User-controlled build options
option(APP_BUILD_EXAMPLES "Build examples" OFF)
option(APP_BUILD_TESTS "Build tests" OFF)


# Install documentation
set(DOC_FILES
	LICENSE.LGPL3.txt
	LICENSE.txt
	NEWS.txt
	README.md
)
if (WIN32)
	install(FILES ${DOC_FILES} DESTINATION doc/)
	install(DIRECTORY docs DESTINATION doc/
		PATTERN "*.yml" EXCLUDE
		PATTERN "CNAME" EXCLUDE
	)
else()
	install(FILES ${DOC_FILES} TYPE DOC)
	install(DIRECTORY docs TYPE DOC
		PATTERN "*.yml" EXCLUDE
		PATTERN "CNAME" EXCLUDE
	)
endif()


# CTest support
include(CTest)
#include(${CMAKE_SOURCE_DIR}/dependencies/catch2/Catch2/extras/Catch.cmake)
include(${CMAKE_SOURCE_DIR}/dependencies/catch2/Catch2/contrib/Catch.cmake)


add_subdirectory(contrib)
add_subdirectory(data)
add_subdirectory(dependencies)
add_subdirectory(packaging)
add_subdirectory(src)


# Packaging support
include(packaging/cpack_options.cmake)

## gsmartcontrol 2.0.1

=== dependencies/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2021 - 2024 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################

# Disable all warnings
if (${CMAKE_CXX_COMPILER_ID} STREQUAL Clang
		OR ${CMAKE_CXX_COMPILER_ID} STREQUAL GNU
		OR ${CMAKE_CXX_COMPILER_ID} STREQUAL AppleClang)
	add_compile_options(-w)
elseif (${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
	add_compile_options(/w)
endif()


find_package(PkgConfig REQUIRED)  # pkg_check_modules()


# Gtkmm.
# Don't make it REQUIRED, we may want to build only the parsers
pkg_check_modules(Gtkmm REQUIRED IMPORTED_TARGET GLOBAL "gtkmm-3.0>=3.0")
add_library(app_gtkmm_interface INTERFACE)
target_link_libraries(app_gtkmm_interface
	INTERFACE
		PkgConfig::Gtkmm
)
target_compile_definitions(app_gtkmm_interface
	INTERFACE
		ENABLE_GLIB=1
		ENABLE_GLIBMM=1
		# For porting to GTK4
#		GTK_DISABLE_DEPRECATED=1
#		GDK_DISABLE_DEPRECATED=1
#		GTKMM_DISABLE_DEPRECATED=1
#		GDKMM_DISABLE_DEPRECATED=1
#		GLIBMM_DISABLE_DEPRECATED=1
#		GIOMM_DISABLE_DEPRECATED=1
)

# Support pre-C++17 glibmm with throw(...) exception specifications
pkg_check_modules(Glibmm "glibmm-2.4")
if ("${Glibmm_VERSION}" VERSION_LESS "2.50.1")
	target_compile_definitions(app_gtkmm_interface INTERFACE "APP_GLIBMM_USES_THROW")
	message(STATUS "Enabling old glibmm throw(...) workaround")
endif()


# Gettext libintl
find_package(Intl REQUIRED)
add_library(app_gettext_interface INTERFACE)
if (Intl_INCLUDE_DIRS)
	target_include_directories(app_gettext_interface
		SYSTEM INTERFACE
			${Intl_INCLUDE_DIRS}
	)
endif()
if (Intl_LIBRARIES)
	target_link_libraries(app_gettext_interface
		INTERFACE
			${Intl_LIBRARIES}
	)
endif()

# Gettext binaries and macros.
# See https://cmake.org/cmake/help/v3.15/module/FindGettext.html
# find_package(Gettext REQUIRED)


add_subdirectory(catch2)
add_subdirectory(nlohmann_json)
add_subdirectory(whereami)
add_subdirectory(tl_expected)

=== src/applib/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2021 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################

add_library(applib STATIC)

target_sources(applib PRIVATE
	async_command_executor.cpp
	async_command_executor.h
	app_builder_widget.h
	app_gtkmm_tools.cpp
	app_gtkmm_tools.h
	app_regex.h
	command_executor.h
	command_executor.cpp
	command_executor_3ware.h
	command_executor_areca.h
	command_executor_gui.cpp
	command_executor_gui.h
	command_executor_factory.cpp
	command_executor_factory.h
	gsc_settings.h
	gui_utils.cpp
	gui_utils.h
	selftest.cpp
	selftest.h
	smartctl_parser.cpp
	smartctl_parser.h
	smartctl_json_ata_parser.cpp
	smartctl_json_ata_parser.h
	smartctl_json_basic_parser.cpp
	smartctl_json_basic_parser.h
	smartctl_json_nvme_parser.cpp
	smartctl_json_nvme_parser.h
	smartctl_json_parser_helpers.h
	smartctl_executor.cpp
	smartctl_executor_gui.h
	smartctl_executor.h
	smartctl_parser_types.h
	smartctl_text_ata_parser.cpp
	smartctl_text_ata_parser.h
	smartctl_text_basic_parser.cpp
	smartctl_text_basic_parser.h
	smartctl_text_parser_helper.cpp
	smartctl_text_parser_helper.h
	smartctl_version_parser.cpp
	smartctl_version_parser.h
	storage_detector.cpp
	storage_detector.h
	storage_detector_helpers.h
	storage_detector_linux.cpp
	storage_detector_linux.h
	storage_detector_other.cpp
	storage_detector_other.h
	storage_detector_win32.cpp
	storage_detector_win32.h
	storage_device.cpp
	storage_device.h
	storage_property.cpp
	storage_property.h
	storage_property_descr.cpp
	storage_property_descr.h
	storage_property_descr_ata_attribute.cpp
	storage_property_descr_ata_attribute.h
	storage_property_descr_ata_statistic.cpp
	storage_property_descr_ata_statistic.h
	storage_property_descr_helpers.h
	storage_property_descr_nvme_attribute.cpp
	storage_property_descr_nvme_attribute.h
	storage_property_repository.cpp
	storage_property_repository.h
	storage_settings.h
	warning_colors.h
	warning_level.h
	window_instance_manager.h
)

target_link_libraries(applib
	PUBLIC
		libdebug
		hz
		rconfig
		app_gtkmm_interface
		app_gettext_interface
		build_config
)

target_include_directories(applib
	PUBLIC
		"${CMAKE_SOURCE_DIR}/src"
)


add_subdirectory(examples)
add_subdirectory(tests)

=== src/libdebug/examples/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2021 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################

if (NOT APP_BUILD_EXAMPLES)
    set_directory_properties(PROPERTIES EXCLUDE_FROM_ALL true)
else()
    set_directory_properties(PROPERTIES EXCLUDE_FROM_ALL false)
endif()


add_executable(example_libdebug)
target_sources(example_libdebug PRIVATE
	example_libdebug.cpp
)
target_link_libraries(example_libdebug PRIVATE
	libdebug
)

=== debian/changelog ===
gsmartcontrol (2.0.1-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Wed, 01 Jan 2025 10:05:15 +0100

gsmartcontrol (2.0.0-1) unstable; urgency=medium

  * New upstream release, merging icon-ui-paths.patch. Closes: #1087224.
  * Track tags instead of releases in debian/watch. Closes: #1087223.

 -- Stephen Kitt <skitt@debian.org>  Sun, 17 Nov 2024 16:48:50 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,14 @@
 Maintainer: Stephen Kitt <skitt@debian.org>
 Section: utils
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
-               libpcre3-dev,
-               libgtkmm-3.0-dev
-Standards-Version: 4.6.0
+Build-Depends: catch2,
+               cmake,
+               debhelper-compat (= 13),
+               libexpected-dev,
+               libgtkmm-3.0-dev,
+               libwhereami-dev,
+               nlohmann-json3-dev
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/gsmartcontrol
 Vcs-Git: https://salsa.debian.org/debian/gsmartcontrol.git

## gsmartcontrol 2.0.2

=== contrib/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2021 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################

if (NOT WIN32)
	install(DIRECTORY "${CMAKE_SOURCE_DIR}/contrib" TYPE DOC
		PATTERN "CMakeLists.txt" EXCLUDE)
endif()

=== data/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2021 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################


# Generate files
configure_file("gsmartcontrol.appdata.in.xml" "gsmartcontrol.appdata.xml" ESCAPE_QUOTES @ONLY)
configure_file("gsmartcontrol.in.desktop" "gsmartcontrol.desktop" ESCAPE_QUOTES @ONLY)
configure_file("gsmartcontrol-root.in.sh" "gsmartcontrol-root.sh" ESCAPE_QUOTES @ONLY)
configure_file("org.gsmartcontrol.in.policy" "org.gsmartcontrol.policy" ESCAPE_QUOTES @ONLY)

# Install app icons
if (NOT WIN32)
	foreach(dir 16 22 24 32 48 64 128 256)
		install(FILES "${dir}/gsmartcontrol.png"
			DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/${dir}x${dir}/apps/")
	endforeach()
	# Don't run update-icon-cache, cpack is mostly for packaging.
#	install(CODE "execute_process (COMMAND gtk-update-icon-cache-3.0 -t -f \"@CMAKE_INSTALL_DATADIR@/icons/hicolor\")")
endif()

if (WIN32)
	# .ico file
	install(FILES gsmartcontrol.ico DESTINATION .)
endif()

set (DATA_ICONS
	icons/drive-optical.png
	icons/drive-harddisk.png
	icons/drive-removable-media-usb.png
)

# Install internal icons
if (WIN32)
	install(FILES ${DATA_ICONS} DESTINATION icons)
else()
	install(FILES ${DATA_ICONS}
		DESTINATION "${CMAKE_INSTALL_DATADIR}/gsmartcontrol/icons")
endif()

# Desktop file
if (NOT WIN32)
	install(FILES "${CMAKE_CURRENT_BINARY_DIR}/gsmartcontrol.desktop"
		DESTINATION "${CMAKE_INSTALL_DATADIR}/applications/")

	# Appdata file
	install(FILES "${CMAKE_CURRENT_BINARY_DIR}/gsmartcontrol.appdata.xml"
		DESTINATION "${CMAKE_INSTALL_DATADIR}/metainfo/")

	# PolKit file
	install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.gsmartcontrol.policy"
		DESTINATION "${CMAKE_INSTALL_DATADIR}/polkit-1/actions/")

	# Man pages
	install(FILES "man1/gsmartcontrol.1" DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")
	install(FILES "man1/gsmartcontrol.1" DESTINATION "${CMAKE_INSTALL_MANDIR}/man1" RENAME "gsmartcontrol-root.1")

	# Scripts (this goes to bin, not sbin, as it doesn't require root privileges before running)
	install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/gsmartcontrol-root.sh" TYPE BIN RENAME "gsmartcontrol-root")
endif()

=== dependencies/CMakeLists.txt ===
--- 
+++ 
@@ -68,6 +68,7 @@
 
 
 add_subdirectory(catch2)
+add_subdirectory(fmt)
 add_subdirectory(nlohmann_json)
 add_subdirectory(whereami)
 add_subdirectory(tl_expected)

=== packaging/CMakeLists.txt ===

# Variables for nsis .in files
set(WINDOWS_SUFFIX "win32")
if (CMAKE_SIZEOF_VOID_P EQUAL 8)
	set(WINDOWS_SUFFIX "win64")
endif()
configure_file("nsis/distribution.in.txt" "nsis/distribution.txt" ESCAPE_QUOTES @ONLY NEWLINE_STYLE DOS)
# configure_file("nsis/gsmartcontrol.in.nsi" "nsis/gsmartcontrol.nsi" ESCAPE_QUOTES @ONLY NEWLINE_STYLE DOS)

# NSIS helpers
if (WIN32)
	install(FILES "${CMAKE_CURRENT_BINARY_DIR}/nsis/distribution.txt" TYPE DOC)

	# nsis file, only for cross-compilation
#	if (NOT ${CMAKE_HOST_SYSTEM_NAME} STREQUAL "Windows")
#		install(FILES "${CMAKE_CURRENT_BINARY_DIR}/nsis/gsmartcontrol.nsi" DESTINATION .)
#	endif()
endif()


# OBS Debian
#configure_file("obs_debian/changelog.in" "obs_debian/changelog" ESCAPE_QUOTES @ONLY)

# OBS RPM
#configure_file(obs_rpm/gsmartcontrol.in.spec obs_rpm/gsmartcontrol.spec)

=== dependencies/catch2/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2021 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################

#add_subdirectory(Catch2)


add_library(Catch2 INTERFACE)

# Relative sources are allowed only since cmake 3.13.
target_sources(Catch2 INTERFACE
	${CMAKE_CURRENT_SOURCE_DIR}/Catch2/single_include/catch2/catch.hpp
)

target_include_directories(Catch2
	SYSTEM INTERFACE
		"${CMAKE_SOURCE_DIR}/dependencies/catch2/Catch2/single_include"
)

=== dependencies/fmt/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2025 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################

add_library(fmt STATIC)

# Relative sources are allowed only since cmake 3.13.
target_sources(fmt PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/src/format.cc
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/args.h
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/base.h
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/chrono.h
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/color.h
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/compile.h
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/core.h
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/format.h
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/format-inl.h
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/os.h
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/ostream.h
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/printf.h
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/ranges.h
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/std.h
	${CMAKE_CURRENT_SOURCE_DIR}/fmt/include/fmt/xchar.h
)

target_include_directories(fmt
	SYSTEM PUBLIC
		"fmt/include"
)

=== dependencies/nlohmann_json/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2021 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################

add_library(nlohmann_json INTERFACE)

# Relative sources are allowed only since cmake 3.13.
target_sources(nlohmann_json INTERFACE
	${CMAKE_CURRENT_SOURCE_DIR}/nlohmann/json.hpp
)

target_include_directories(nlohmann_json
	SYSTEM INTERFACE
		"${CMAKE_SOURCE_DIR}/dependencies/nlohmann_json"
)

=== dependencies/tl_expected/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2024 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################


add_library(tl_expected INTERFACE)

# Relative sources are allowed only since cmake 3.13.
target_sources(tl_expected INTERFACE
	${CMAKE_CURRENT_SOURCE_DIR}/expected/include/tl/expected.hpp
)

target_include_directories(tl_expected
	SYSTEM INTERFACE
		"${CMAKE_SOURCE_DIR}/dependencies/tl_expected/expected/include"
)

=== dependencies/whereami/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2022 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################

add_library(whereami STATIC)

target_sources(whereami PRIVATE
	whereami/src/whereami.cpp
	whereami/src/whereami.h
)

target_include_directories(whereami
	SYSTEM PUBLIC
		"${CMAKE_CURRENT_SOURCE_DIR}/whereami/src"
)

=== src/applib/CMakeLists.txt ===
--- 
+++ 
@@ -84,6 +84,7 @@
 		rconfig
 		app_gtkmm_interface
 		app_gettext_interface
+		fmt
 		build_config
 )

=== src/gui/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2021 - 2024 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################

# gsmartcontrol binary
add_executable(gsmartcontrol WIN32)

target_sources(gsmartcontrol PRIVATE
	gsc_about_dialog.cpp
	gsc_about_dialog.h
	gsc_add_device_window.cpp
	gsc_add_device_window.h
	gsc_executor_error_dialog.cpp
	gsc_executor_error_dialog.h
	gsc_executor_log_window.cpp
	gsc_executor_log_window.h
	gsc_info_window.cpp
	gsc_info_window.h
	gsc_init.cpp
	gsc_init.h
	gsc_main.cpp
	gsc_main_window.cpp
	gsc_main_window.h
	gsc_main_window_iconview.cpp
	gsc_main_window_iconview.h
	gsc_preferences_window.cpp
	gsc_preferences_window.h
	gsc_startup_settings.h
	gsc_text_window.h
)

# Win32 resource file
if (WIN32)
	configure_file("gsc_winres.in.rc" "${CMAKE_CURRENT_BINARY_DIR}/gsc_winres.rc" ESCAPE_QUOTES @ONLY NEWLINE_STYLE DOS)
	file(COPY "${CMAKE_SOURCE_DIR}/data/gsmartcontrol.ico" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")  # required by winres
	target_sources(gsmartcontrol PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/gsc_winres.rc")
endif()

# Win32 manifest
if (WIN32)
	set(WINDOWS_ARCH "x86")  # Needed for manifest .in file
	if (CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(WINDOWS_ARCH "amd64")
	endif()
	configure_file("gsmartcontrol.exe.in.manifest" "${CMAKE_CURRENT_BINARY_DIR}/gsmartcontrol.exe.manifest"
		ESCAPE_QUOTES @ONLY NEWLINE_STYLE DOS)

	# We link the manifest into the binary instead of installing it.
	# install(FILES "${CMAKE_CURRENT_BINARY_DIR}/gsmartcontrol.exe.manifest" DESTINATION "${CMAKE_INSTALL_SBINDIR}/")
	target_sources(gsmartcontrol PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/gsmartcontrol.exe.manifest")
endif()


target_link_libraries(gsmartcontrol
	PRIVATE
		applib
		app_gtkmm_interface
		build_config
)

if (WIN32)
	install(TARGETS gsmartcontrol DESTINATION .)
else()
	install(TARGETS gsmartcontrol DESTINATION "${CMAKE_INSTALL_SBINDIR}/")
endif()


add_subdirectory(ui)

=== src/hz/CMakeLists.txt ===
###############################################################################
# License: BSD Zero Clause License file
# Copyright:
#   (C) 2021 Alexander Shaduri <ashaduri@gmail.com>
###############################################################################

add_library(hz INTERFACE)

# Relative sources are allowed only since cmake 3.13.
target_sources(hz INTERFACE
	${CMAKE_CURRENT_SOURCE_DIR}/bad_cast_exception.h
	${CMAKE_CURRENT_SOURCE_DIR}/data_file.h
	${CMAKE_CURRENT_SOURCE_DIR}/debug.h
	${CMAKE_CURRENT_SOURCE_DIR}/enum_helper.h
	${CMAKE_CURRENT_SOURCE_DIR}/env_tools.h
	${CMAKE_CURRENT_SOURCE_DIR}/error_container.h
	${CMAKE_CURRENT_SOURCE_DIR}/error_holder.h
	${CMAKE_CURRENT_SOURCE_DIR}/format_unit.h
	${CMAKE_CURRENT_SOURCE_DIR}/fs.h
	${CMAKE_CURRENT_SOURCE_DIR}/fs_ns.h
	${CMAKE_CURRENT_SOURCE_DIR}/launch_url.h
	${CMAKE_CURRENT_SOURCE_DIR}/locale_tools.h
	${CMAKE_CURRENT_SOURCE_DIR}/main_tools.h
	${CMAKE_CURRENT_SOURCE_DIR}/process_signal.h
	${CMAKE_CURRENT_SOURCE_DIR}/stream_cast.h
	${CMAKE_CURRENT_SOURCE_DIR}/string_algo.h
	${CMAKE_CURRENT_SOURCE_DIR}/string_num.h
	${CMAKE_CURRENT_SOURCE_DIR}/string_sprintf.h
	${CMAKE_CURRENT_SOURCE_DIR}/system_specific.h
	${CMAKE_CURRENT_SOURCE_DIR}/win32_tools.h
)

target_link_libraries(hz
	INTERFACE
#		libdebug
		app_gtkmm_interface  # ENABLE_* macros
		app_gettext_interface  # format_unit.h uses this
		libdebug  # debug.h
		whereami  # whereami.h
		tl_expected  # error_container.h
#		std::filesystem  # fs_ns.h, linking to stdc++fs / c++fs if needed
)

# Support <experimental/filesystem> if needed
#if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
#	target_link_libraries(hz
#		INTERFACE
#			stdc++fs
#	)
#endif()

target_include_directories(hz
	INTERFACE
		"${CMAKE_SOURCE_DIR}/src"
)

target_compile_definitions(hz
	INTERFACE
		HZ_USE_LIBDEBUG=1
)


add_subdirectory(tests)

=== debian/changelog ===
gsmartcontrol (2.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 4.7.2, no change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 03 Mar 2025 21:46:29 +0100

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,11 @@
                cmake,
                debhelper-compat (= 13),
                libexpected-dev,
+               libfmt-dev,
                libgtkmm-3.0-dev,
                libwhereami-dev,
                nlohmann-json3-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/gsmartcontrol
 Vcs-Git: https://salsa.debian.org/debian/gsmartcontrol.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DAPP_COMPILER_ENABLE_WARNINGS=ON -DAPP_BUILD_TESTS=ON

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
    https://github.com/ashaduri/gsmartcontrol/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
